<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">

<html lang="en">
<head>

<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">

<meta name="generator" content="PHPDoctor 2RC4 (http://peej.github.com/phpdoctor/)">
<meta name="when" content="Fri, 15 Apr 2011 16:43:07 +0000">

<link rel="stylesheet" type="text/css" href="../../../stylesheet.css">
<link rel="start" href="../../../overview-summary.html">

<title>doclets/standard/sourceWriter.php (PHPDoctor)</title>

</head>
<body id="file" onload="parent.document.title=document.title;">

<div class="header">
<h1>PHPDoctor</h1>
<ul>
<li><a href="../../../overview-summary.html">Overview</a></li>
<li>Package</li><li>Class</li><li>Tree</li><li><a href="../../../overview-files.html">Files</a></li>
<li><a href="../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../todo-list.html">Todo</a></li>
<li><a href="../../../index-all.html">Index</a></li>
</ul>
</div>

<div class="small_links">
<a href="../../../index.html" target="_top">Frames</a>
<a href="../../../source/doclets/standard/sourcewriter.php.html" target="_top">No frames</a>
</div>
<hr>

<h1>doclets/standard/sourceWriter.php</h1>
<hr>

<a name="line1"></a><pre><?php
<a name="line2"></a>/*
<a name="line3"></a>PHPDoctor: The PHP Documentation Creator
<a name="line4"></a>Copyright (C) 2010 Paul James <paul@peej.co.uk>
<a name="line5"></a>
<a name="line6"></a>This program is free software; you can redistribute it and/or modify
<a name="line7"></a>it under the terms of the GNU General Public License as published by
<a name="line8"></a>the Free Software Foundation; either version 2 of the License, or
<a name="line9"></a>(at your option) any later version.
<a name="line10"></a>
<a name="line11"></a>This program is distributed in the hope that it will be useful,
<a name="line12"></a>but WITHOUT ANY WARRANTY; without even the implied warranty of
<a name="line13"></a>MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
<a name="line14"></a>GNU General Public License for more details.
<a name="line15"></a>
<a name="line16"></a>You should have received a copy of the GNU General Public License
<a name="line17"></a>along with this program; if not, write to the Free Software
<a name="line18"></a>Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
<a name="line19"></a>*/
<a name="line20"></a>
<a name="line21"></a>/** This uses GeSHi to generate formatted source for each source file in the
<a name="line22"></a> * parsed code.
<a name="line23"></a> *
<a name="line24"></a> * @package PHPDoctor\Doclets\Standard
<a name="line25"></a> */
<a name="line26"></a>class SourceWriter extends HTMLWriter
<a name="line27"></a>{
<a name="line28"></a>
<a name="line29"></a>	/** Parse the source files.
<a name="line30"></a>	 *
<a name="line31"></a>	 * @param Doclet doclet
<a name="line32"></a>	 */
<a name="line33"></a>	function sourceWriter(&$doclet)
<a name="line34"></a>    {
<a name="line35"></a>	
<a name="line36"></a>		parent::HTMLWriter($doclet);
<a name="line37"></a>		
<a name="line38"></a>		$rootDoc =& $this->_doclet->rootDoc();
<a name="line39"></a>		$phpdoctor =& $this->_doclet->phpdoctor();
<a name="line40"></a>		
<a name="line41"></a>        $this->_sections[0] = array('title' => 'Overview', 'url' => 'overview-summary.html');
<a name="line42"></a>        $this->_sections[1] = array('title' => 'Namespace');
<a name="line43"></a>        $this->_sections[2] = array('title' => 'Class');
<a name="line44"></a>        //$this->_sections[3] = array('title' => 'Use');
<a name="line45"></a>        if ($phpdoctor->getOption('tree')) $this->_sections[4] = array('title' => 'Tree', 'url' => 'overview-tree.html');
<a name="line46"></a>        $this->_sections[5] = array('title' => 'Files', 'url' => 'overview-files.html', 'selected' => TRUE);
<a name="line47"></a>        $this->_sections[6] = array('title' => 'Deprecated', 'url' => 'deprecated-list.html');
<a name="line48"></a>        $this->_sections[7] = array('title' => 'Todo', 'url' => 'todo-list.html');
<a name="line49"></a>        $this->_sections[8] = array('title' => 'Index', 'url' => 'index-all.html');
<a name="line50"></a>        
<a name="line51"></a>		$sources =& $rootDoc->sources();
<a name="line52"></a>        
<a name="line53"></a>        $this->_id = 'files';
<a name="line54"></a>        
<a name="line55"></a>        ob_start();
<a name="line56"></a>        
<a name="line57"></a>        echo "<hr>\n\n";
<a name="line58"></a>        
<a name="line59"></a>        echo '<h1>Source Files</h1>';
<a name="line60"></a>        
<a name="line61"></a>        echo "<ul>\n";
<a name="line62"></a>        foreach ($sources as $filename => $data) {
<a name="line63"></a>            $url = strtolower(str_replace(DIRECTORY_SEPARATOR, '/', $filename));
<a name="line64"></a>            echo '<li><a href="source/', $url, '.html">', $filename, '</a></li>';
<a name="line65"></a>        }
<a name="line66"></a>        echo "</ul>\n";
<a name="line67"></a>        
<a name="line68"></a>        $this->_output = ob_get_contents();
<a name="line69"></a>        ob_end_clean();
<a name="line70"></a>        
<a name="line71"></a>        $this->_write('overview-files.html', 'Overview', TRUE);
<a name="line72"></a>    	
<a name="line73"></a>        
<a name="line74"></a>		$this->_id = 'file';
<a name="line75"></a>		
<a name="line76"></a>		foreach ($sources as $filename => $data) {
<a name="line77"></a>		    
<a name="line78"></a>			$this->_sections[0] = array('title' => 'Overview', 'url' => 'overview-summary.html');
<a name="line79"></a>			$this->_sections[1] = array('title' => 'Package');
<a name="line80"></a>			$this->_sections[2] = array('title' => 'Class');
<a name="line81"></a>			//$this->_sections[3] = array('title' => 'Use');
<a name="line82"></a>			if ($phpdoctor->getOption('tree')) $this->_sections[4] = array('title' => 'Tree');
<a name="line83"></a>			$this->_sections[5] = array('title' => 'Files', 'url' => 'overview-files.html');
<a name="line84"></a>			$this->_sections[6] = array('title' => 'Deprecated', 'url' => 'deprecated-list.html');
<a name="line85"></a>			$this->_sections[7] = array('title' => 'Todo', 'url' => 'todo-list.html');
<a name="line86"></a>			$this->_sections[8] = array('title' => 'Index', 'url' => 'index-all.html');
<a name="line87"></a>			
<a name="line88"></a>            $this->_depth = substr_count($filename, '/') + 1;
<a name="line89"></a>            
<a name="line90"></a>            if (class_exists('GeSHi')) {
<a name="line91"></a>                $geshi = new GeSHi($data[0], 'php');
<a name="line92"></a>                $source = $geshi->parse_code();
<a name="line93"></a>            } else {
<a name="line94"></a>                $source = '<pre>'.$data[0].'</pre>';
<a name="line95"></a>            }
<a name="line96"></a>            
<a name="line97"></a>            ob_start();
<a name="line98"></a>            
<a name="line99"></a>            echo "<hr>\n\n";
<a name="line100"></a>            echo '<h1>'.$filename."</h1>\n";
<a name="line101"></a>            
<a name="line102"></a>            if (isset($data[1]['tags']['@text'])) {
<a name="line103"></a>                echo '<div class="comment" id="overview_description">', $this->_processInlineTags($data[1]['tags']['@text']), "</div>\n\n";
<a name="line104"></a>            }
<a name="line105"></a>            
<a name="line106"></a>            echo "<hr>\n\n";
<a name="line107"></a>            
<a name="line108"></a>            foreach (explode("\n", $source) as $index => $line) {
<a name="line109"></a>                echo '<a name="line'.($index + 1).'"></a>'.$line."\n";
<a name="line110"></a>            }
<a name="line111"></a>            
<a name="line112"></a>            $this->_output = ob_get_contents();
<a name="line113"></a>            ob_end_clean();
<a name="line114"></a>            
<a name="line115"></a>            $this->_write('source/'.strtolower($filename).'.html', $filename, TRUE);
<a name="line116"></a>            
<a name="line117"></a>		}
<a name="line118"></a>		
<a name="line119"></a>    }
<a name="line120"></a>}
<a name="line121"></a></pre>
<div class="header">
<h1>PHPDoctor</h1>
<ul>
<li><a href="../../../overview-summary.html">Overview</a></li>
<li>Package</li><li>Class</li><li>Tree</li><li><a href="../../../overview-files.html">Files</a></li>
<li><a href="../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../todo-list.html">Todo</a></li>
<li><a href="../../../index-all.html">Index</a></li>
</ul>
</div>

<div class="small_links">
<a href="../../../index.html" target="_top">Frames</a>
<a href="../../../source/doclets/standard/sourcewriter.php.html" target="_top">No frames</a>
</div>
<hr>

<p id="footer">This document was generated by <a href="http://peej.github.com/phpdoctor/">PHPDoctor: The PHP Documentation Creator</a></p>

</body>

</html>